/*
---------------------------------------
All rights reserved
(C) copyright 2002 Gogul Balakrishnan
---------------------------------------
This is a part of the OS, Gogul is writing currently.  Permission to use, copy, modify and distribute this software  and documentation is granted without fee, provided this  copyright message appears on all distributions.I make no  representations of the suitability of the software for any  purpose whatsoever. It is provided "as is" without any  express or implied warranty.

*/

#ifndef __KEY_B_H
#define __KEY_B_H

#include <defs.h>

#define EXTENDED_KEY 0xe0

#define KEYB_BUF_SIZE	32

#define KEYB_PORT		0x60

#define ESC		27
#define BS		8
#define HTAB	9
#define ENTER	13

#define CTRL	29
#define LSHIFT	42
#define RSHIFT	54
#define ALT		56

#define CAPSLOCK 	58
#define F1		59
#define F2		60
#define F3		61
#define F4		62
#define F5		63
#define F6		64
#define F7		65
#define F8		66 
#define F9		67
#define F10		68
#define NUMLOCK	69
#define SCRLLOCK	70
#define HOME	71
#define UP		72
#define PGUP	73
#define LEFT	75
#define RIGHT	77
#define END		79
#define DOWN	80
#define PGDN	81
#define INSERT	82
#define DEL		83
#define F11		87
#define F12		88


#define INS_MASK		0x80
#define CAPS_MASK		0x40
#define NUM_MASK		0x20
#define SCRL_MASK		0x10
#define ALT_MASK		0x08
#define CTRL_MASK		0x04
#define LSHIFT_MASK	0x02
#define RSHIFT_MASK	0x01

/*queue*/
struct keyboard_buffer_t {
	BYTE strokes[KEYB_BUF_SIZE];
	BYTE head,tail;
};

void int_keyb_handler(void);

#endif