/*
---------------------------------------
All rights reserved
(C) copyright 2002 Gogul Balakrishnan
---------------------------------------
This is a part of the OS, Gogul is writing currently.  Permission to use, copy, modify and distribute this software  and documentation is granted without fee, provided this  copyright message appears on all distributions.I make no  representations of the suitability of the software for any  purpose whatsoever. It is provided "as is" without any  express or implied warranty.

*/

#ifndef __TERM_H
#define __TERM_H

#include <keyb.h>

#define SCR_ROWS	25
#define SCR_COLS	80

#define MAX_TERMINALS 10


struct text_screen_buffer_t {
	BYTE buffer[SCR_ROWS][SCR_COLS*2];
	int first_row;
};

struct term_t {
	struct keyboard_buffer_t kb_buff;
	struct text_screen_buffer_t scr_buff;
	BYTE curx,cury;
	BYTE kb_status;
};

extern struct term_t terminals[MAX_TERMINALS];
extern int cur_terminal;

void init_terminals();
void printk(uchar termno,uchar val);
void refresh_terminal(uchar termno);
void switch_terminal(uchar termno);
void update_scr(uint curx,uint cury,uchar val,uchar attr);
#endif

