/*
---------------------------------------
All rights reserved
(C) copyright 2001 Gogul Balakrishnan
---------------------------------------
This is a part of the OS, Gogul is writing currently. Permission to use, copy, modify and distribute this software and documentation is granted without fee, provided this copyright message appears on all distributions.I make no representations of the suitability of the software for any purpose whatsoever. It is provided "as is" without any express or implied warranty.

*/


#include <term.h>

struct term_t terminals[MAX_TERMINALS];
int cur_terminal=0; 

void init_terminals() {
	uint i,j,k;
	struct text_screen_buffer_t *scr;
	struct term_t *t;
	for(i=0;i<MAX_TERMINALS;++i) {
		scr=&terminals[i].scr_buff;
		t=&terminals[i];
		t->curx=0;
		t->cury=0;
		t->kb_status=0;
		scr->first_row=0;
		for(j=0;j<SCR_ROWS;j++) {
			for(k=0;k<SCR_COLS*2;k+=2) {
				scr->buffer[j][k]=' ';
				scr->buffer[j][k+1]=0x7;
			}
		}
	}
	cur_terminal=0;
}

void printk(uchar termno,uchar val){
	struct text_screen_buffer_t *scr;
	struct term_t *t;
	uint curx,cury;
	int buf_row;
	uint i;

	scr=&terminals[termno].scr_buff;
	t=&terminals[termno];

	curx=t->curx;
	cury=t->cury;

	buf_row=(scr->first_row+cury)%SCR_ROWS;
	
	scr->buffer[buf_row][curx*2]=val;
	scr->buffer[buf_row][curx*2+1]=0x7;
	
	t->curx++;
	if(t->curx==SCR_COLS) {
		t->curx=0;
		t->cury++;
		if(t->curx==0 && t->cury==SCR_ROWS) { 
			/* Characters have gone past the 
			   end of the terminal screen. so scroll*/
			buf_row=scr->first_row;
			scr->first_row=(scr->first_row+1)%SCR_ROWS;
			for(i=0;i<(SCR_COLS*2);i+=2) {
				scr->buffer[buf_row][i]=(BYTE)32;
				scr->buffer[buf_row][i+1]=(BYTE)0x7;
			}
			t->cury=SCR_ROWS-1;
			if(cur_terminal==termno) refresh_terminal(termno);
			//t->curx=SCR_COLS-1;
			//if(cur_terminal==termno) update_scr(curx,cury,val,0x7);
			goto exit_printk;
		}
	}

	if(cur_terminal==termno) update_scr(curx,cury,val,0x7);
exit_printk:
	return;
}

void refresh_terminal(uchar termno){
	BYTE *pos;
	struct text_screen_buffer_t *scr;
	uint scr_off;
	uint row;
	int f;
	int i,j;
	f=terminals[termno].scr_buff.first_row;
	scr=&terminals[termno].scr_buff;
	for(i=0;i<SCR_ROWS;++i){
		row=(f+i)%SCR_ROWS;
		for(j=0;j<SCR_COLS*2;j+=2) {
			update_scr(j>>1,i,scr->buffer[row][j],scr->buffer[row][j+1]);
		}
	}
/*
	__asm__("push %es");
	__asm__("mov %0,%%eax"::"g" (SCR_SEL):"%eax");
	__asm__("mov %eax,%es");

	 for(i=0;i<SCR_ROWS;++i) {
		 row=(f+i)%SCR_ROWS;
		 pos=scr->buffer[row];
		 scr_off=i*160;
		 asm("mov %0,%%si": :"g"(pos):"%si");
		 asm("mov %0,%%di": :"g"(scr_off):"%di");
		 asm("mov $160,%%ecx": : :"%ecx");
		 asm("rep movsb");
	 }
	__asm__("pop %es");

 */
}



void update_scr(uint curx,uint cury,uchar val,uchar attr) {
	DWORD pos=0;
	
	/* HARDCODED scr_selector */
	pos=(cury * 160);
	pos=pos+(curx+curx);
	
	__asm__("push %ds");
	asm("mov %0,%%ebx"::"g"(SCR_SEL):"%ebx");
	__asm__("mov %ebx,%ds");

	*((BYTE *)pos)=val;
	*((BYTE *)pos+1)=attr;

	__asm__("pop %ds");
}


void switch_terminal(uchar termno){
	cur_terminal=termno;
	refresh_terminal(termno);
}

void display_test(){
	uint i,j;
	while(1){
			
		//for(j=0;j<MAX_TERMINALS;++j) {
		for(i=32;i<128;++i)
		//	update_scr(10,0,'a',0x7);
			printk(0,i);
		for(j=0;j<100000;++j);
		//	switch_terminal(j);
		//}
	}

}
